// Author: 0626108 LF02
// Purpose: To access methods in the BankAccount class to manipulate its members

import java.util.*;
import java.io.*;

public class PATM {

    static Scanner n = new Scanner(System.in); //user input Scanner initialized globally.

    public static void main(String[] args) throws IOException {

        BankAccount b = new BankAccount(); //two bank account objects
        BankAccount c = new BankAccount();

		File inFile = new File("BankInfoInput.txt"); //input file
    	Scanner f = new Scanner(inFile); //file Scanner

    	b.setAccountNumber(f.next()); //delimiter is a space
    	b.setPassword(encrypt(f.next())); //reverses the password written in the file. If the algorithm was more complex, a decrypt() method would be needed. In fact, because the encryption method is symmetrical I could've called the method crypt()
    	b.setBalance(f.nextDouble());

    	c.setAccountNumber(f.next()); //b[] would make a LOT more sense. This program could be expanded endlessly with a boundless array
		c.setPassword(encrypt(f.next()));
    	c.setBalance(f.nextDouble());

		int sel = 0; //option selected by user
		char mode = '\0'; //determines which line of code is being used.  Again, arrays would be a lot better.
		int tries = 3; //number of tries to input password correctly
		String bNum = b.getAccountNumber(); //Holds the account numbers for strings for comparison in .equals() method
		String cNum = c.getAccountNumber();
		String enter = "\0"; //user input
		String bPass = b.getPassword();
		String cPass = c.getPassword();
		boolean rightPassword;

		while (mode != 'b' && mode != 'c') {

			System.out.println("Enter account number: ");
			enter = n.next();

			if (enter.equals(bNum)) mode = 'b'; //determines which of the two accounts will be manipulated
			if (enter.equals(cNum)) mode = 'c';

		}

		do {

			rightPassword = true; //if nothing goes wrong, the loop will exit fine

			System.out.println("Enter password: ");

			if (mode == 'b') {

				enter = n.next();

				if (enter.equals(bPass) == false) {

					tries--;
					rightPassword = false;
					System.out.println("Wrong Password! " + tries + " tries remaining.");

				}

			}

			if (mode == 'c') {

				enter = n.next();

				if (enter.equals(cPass) == false) {

					tries--;
					rightPassword = false;
					System.out.println("Wrong Password! " + tries + " tries remaining.");

				}

			}

			if (tries < 1) rightPassword = true; //force exit if out of tries

		} while (rightPassword == false); //end of do

		if (tries < 1) sel = 6; //skip entire program if out of tries.

		while (sel < 5) {

			System.out.println(""); //prints a blank line after any method finishes
			System.out.println("Select a mode:");
			System.out.println("");
			System.out.println("1. Change password");
			System.out.println("2. Check balance");
			System.out.println("3. Deposit");
			System.out.println("4. Withdraw");
			System.out.println("5. Exit");

			sel = n.nextInt();

			switch (sel) {
				case 1:
					if (mode == 'b') changePassword(b); //these have to be copied for each account because I can't use arrays
					if (mode == 'c') changePassword(c);
					break;

				case 2:
					if (mode == 'b') viewBalance(b);
					if (mode == 'c') viewBalance(c);
					break;

				case 3:
					if (mode == 'b') deposit(b);
					if (mode == 'c') deposit(c);
					break;

				case 4:
					if (mode == 'b') withdraw(b);
					if (mode == 'c') withdraw(c);
					break;

				default:
					break;

				} //end of switch (sel)

		}

    	//output new values
		FileWriter fw = new FileWriter("BankInfoOutput.txt"); //output file
		BufferedWriter bw = new BufferedWriter(fw); //file writer

		bw.write(b.getAccountNumber() + " " + encrypt(b.getPassword()) + " " + b.getBalance());
		bw.newLine();
		bw.write(c.getAccountNumber() + " " + encrypt(c.getPassword()) + " " + c.getBalance());
		bw.newLine();

		bw.close();

		System.out.println("");

    } //end main()

    public static void changePassword(BankAccount p) {

		boolean validPassWord = true;
		String newPassWord = "\0";

		System.out.println("Enter new password.  It must:");
		System.out.println(" - Begin with a non-alphanumeric character (!, *, #, etc.)");
		System.out.println(" - Follow with 5-7 alphanumeric characters. They may be uppercase or lowercase.");
		//I have left out the need for an old password because it was already entered to get this far

		do {

			validPassWord = true; //if nothing goes wrong, the loop will exit fine

			newPassWord = n.next();

			if (newPassWord.length() > 8 || newPassWord.length() < 6) {

				System.out.println("Password is of invalid length! Choose another.");
				validPassWord = false;

			}

			if ((newPassWord.charAt(0) > 47 && newPassWord.charAt(0) < 58) || (newPassWord.charAt(0) > 64 && newPassWord.charAt(0) < 91) || (newPassWord.charAt(0) > 96 && newPassWord.charAt(0) < 123)) { //numbers, uppercase letters, lowercase letters

				System.out.println("Password must begin with a non-alphanumeric character! Choose another.");
				validPassWord = false;

			}

			for (int i = 1; i < newPassWord.length(); i++) {

				if (newPassWord.charAt(i) < 48 || (newPassWord.charAt(i) > 57 && newPassWord.charAt(i) < 65) || (newPassWord.charAt(i) > 90 && newPassWord.charAt(i) < 97) || newPassWord.charAt(i) > 122) { //checks each character for characters outside of alphanumeric ones

					System.out.println("Rest of password must contain alphanumeric characters! Choose another.");
					validPassWord = false;

				}

			}

		} while (validPassWord == false); //end of do

		p.setPassword(newPassWord);

	} //end changePassword()

	public static String encrypt(String pword) {

		String pword2 = "";

		for (int i = 0; i < pword.length(); i++) {

			pword2 += pword.charAt(pword.length() - i - 1);

		}

		return pword2;

	} //end encrypt()

    public static void viewBalance(BankAccount v) {

		System.out.println("Current balance: " + v.getBalance());

	} //end viewBalance()

    public static void deposit(BankAccount d) {

		double dep = 0;

		do {

			System.out.println("Enter deposit amount.  Must be greater than 0.");

			dep = n.nextDouble();

		} while (dep < 0);

		d.modifyBalance(dep);

		System.out.println(dep + " added to account.");

	} //end deposit()

    public static void withdraw(BankAccount w) {

		double take = 0;

		do {

			System.out.println("Enter an amount to withdraw.  Must be in positive multiples of 10, and less");
			System.out.println("than the balance of the account.");

			take = n.nextDouble();

		} while ((take % 10 != 0) || (take > w.getBalance()) || take < 0);

		w.modifyBalance((take * -1));

		System.out.println(take + " subtracted from account.");

	} //end withdraw()

} //end of PATM

/*Output:

Enter account number:
SVA34967065276593472689372
Enter account number:
SAV1243
Enter password:
!woffy
Wrong Password! 2 tries remaining.
Enter password:
!doggy

Select a mode:

1. Change password
2. Check balance
3. Deposit
4. Withdraw
5. Exit
1
Enter new password.  It must:
 - Begin with a non-alphanumeric character (!, *, #, etc.)
 - Follow with 5-7 alphanumeric characters. They may be uppercase or lowercase.
1kitty
Password must begin with a non-alphanumeric character! Choose another.
1lhfdyhylsdlitwia
Password is of invalid length! Choose another.
Password must begin with a non-alphanumeric character! Choose another.
!kitt^
Rest of password must contain alphanumeric characters! Choose another.
!kitty

Select a mode:

1. Change password
2. Check balance
3. Deposit
4. Withdraw
5. Exit
3
Enter deposit amount.  Must be greater than 0.
-7
Enter deposit amount.  Must be greater than 0.
1337
1337.0 added to account.

Select a mode:

1. Change password
2. Check balance
3. Deposit
4. Withdraw
5. Exit
4
Enter an amount to withdraw.  Must be in positive multiples of 10, and less
than the balance of the account.
-10
Enter an amount to withdraw.  Must be in positive multiples of 10, and less
than the balance of the account.
999
Enter an amount to withdraw.  Must be in positive multiples of 10, and less
than the balance of the account.
13730
Enter an amount to withdraw.  Must be in positive multiples of 10, and less
than the balance of the account.
900
900.0 subtracted from account.

Select a mode:

1. Change password
2. Check balance
3. Deposit
4. Withdraw
5. Exit
2
Current balance: 1461.96

Select a mode:

1. Change password
2. Check balance
3. Deposit
4. Withdraw
5. Exit
5

Press any key to continue . . .

*/
